
OsculatingPlane::usage = "OsculatingPlane[f, u, x, du] gives the plane through 
the tangent and principal normal to the function f: R -> R ^ 3 at f[u]."

OsculatingPlane[f_, u_?NumberQ, x_?NumberQ, du_:.01] := Plane @ 
	{
		f[u], 
		Tangent[f, u, x, du][[1, 2]], 
		PrincipalNormal[f, u, x, du][[1, 2]]
	}

OsculatingPlane[f_, l_List, x_?NumberQ, du_:.01] := 
	OsculatingPlane[f, #, x, du] & /@ l 

