
PrincipalNormal::usage = "PrincipalNormal[f, u, x, du] gives the ray of length 
x from f[u] perpendicular to the tangent of f: R -> R ^ 3 in the osculating 
plane of f."

PrincipalNormal[f_, u_?NumberQ, x_?NumberQ, du_:.01] := Module[
	{v}, 
	v = Cross[
		Vector[Binormal[f, u, x, du]], 
		Vector[Tangent[f, u, x, du]] ];
	Ray[Line[{ f[u], f[u] + v}], x] 
] 

PrincipalNormal[f_, l_List, x_, du_:.01] := 
	PrincipalNormal[f, #, x, du] & /@ l 
