
Angle::usage = "Angle[p, q], where p and q are points, gives the angle 
p $o q. Angle[l, m], where l and m are lines, gives the angle between them.
Angle[{p, q, r}], where p, q and r are points, gives the angle in radians 
between the line from q to p and the line from q to r."

Angle[p_, q_] := Re @ ArcCos[p . q / (Norm[p] Norm[q])] 

Angle[l_Line, m_Line] := Angle[Vector @ l, Vector @ m]

Angle @ {p_, q_, r_} := Angle[p - q, r - q] 

