
Perpendicular::usage = "Perpendicular[p, l] is the line at right angles to l (a line or a plane) passing through the point p."

Perpendicular[p:{_, _, _}, l:Line @ {q_, r_}] := Block[{s, a, b, x},
	s = {-$j, $i, $k};
	a = s . (q - p) + p;
	b = s . (r - p) + p;
	x = If[a == p, b, a];
	Stretch[Line[{x, Reflect[l][x]}], 1] ] /;  Distance[p, l] == 0 

Perpendicular[p:{_, _, _}, l_Line] := 
	Line[{p, Reflect[l][p]}] /; Distance[p, l] > 0 

Perpendicular[l_Line, p:{_, _, _}] := Perpendicular[p, l]


Perpendicular[p:{_, _, _}, l:Plane @ {q_, r_, s_}] := Block[{x, y},
	x = If[p==q, Cross[r - p, s - p], 
		If[p==r, Cross[q - p, s - p], 
			Cross[q - p, r - p]]]; 
	y = If[p==q, Cross[s - p, r - p], 
		If[p==r, Cross[s - p, q - p], 
			Cross[r - p, r - p]]]; 
	Stretch[Line[{x, y}], 1] ] /;  Distance[p, l] == 0 

Perpendicular[p:{_, _, _}, w_Plane] := 
	Line[{p, Reflect[w][p]}] /; Distance[p, w] > 0 

Perpendicular[w_Plane, p:{_, _, _}] := Perpendicular[p, w]