
TangentPoints::usage = "TangentPoints[p, u], where p is a point and u is a 
circle, is the pair of points where the tangents from p to u meet the circle u."

Tangents::usage = "Tangents[p, u], where p is a point and u is a circle, is 
the pair of lines that are tangent to u from the point p."

TangentPoints[p_, Circle[c_, r_]] := {p, p} /; Distance[p, c] == r 

TangentPoints[p_, u:Circle[c_, r_]] := 
	Meet[u, Polar[p, u]] /; Distance[p, c] > r 

TangentPoints[u_Circle, p_] := TangentPoints[p, u] 

( Tangents[p_, u:Circle[c_, r_]] := 
	{#, #} & @ Perpendicular[Line @ {p, c}, p]
	/; Distance[p, c] == r )

( Tangents[p_, u:Circle[c_, r_]] := 
	Line[{p, #}] & /@ TangentPoints[p, u] 
	/; Distance[p, c] > r )

Tangents[u_Circle, p_] := Tangents[p, u]

(*
ExternalTangents[Circle[c_, r_], Circle[d_, s_]] := Module[
	{},
	x = tangentPointts[d, Circle[c, r-s];
	y = Dilate[c, r/(r-s)] @ x;
	z1 = Select[
		TangentPoints[y1, Circle[d, s], 
		!SeparatesQ[y, Line @ {c, d}, #]
	];
	z2 = similar
] /; r > s)

InternalTangents[]
	same except use r+s instead of r-s and SeparatesQ instead of !SeparatesQ

SeparatesQ[p_, l_, q_] := Module[
	{},
	m = Meet[l, Line @ {p, q}];
	Distance[p, m] + Distance[m, q] == Distance[p, q]
]
*)