CrissCross[m_, n_, x_, surface_, displace_] := 
Show @ Graphics3D @ {
Skin[m, n, x, CrissCrossPolygons, surface], 
	Translate[displace (ViewPoint /. Options[Graphics3D])] @ 
	Skin[m, n, x, CrissCrossLines, surface]}

CrissCrossLines[m_, n_, x_] := Module[
	{y, a, b, c, d, e, f, g, h, i, j, k, l, figure},
	y = (.5 - x) / 2; 
	a = y $i / m; 
	b = (x+y) $i / m; 
	c = (x+y) $i / m + y $j / m;
	d = (x+y) $i / m + (x+y) $j / n; 
	e = (x+y) $i / m + .5 $j / n; 
	f = y $i / m + .5 $j / n;
	g = y $i / m + (x+y) $j / n;
	h = y $i / m + y $j / n;
	i = .5 $i / m + y $j / n; 
	j = .5 $i / m + (x+y) $j / n;
	k = (x+y) $j / n;
	l = y $j / n; 
	figure = { 
		Black, 
		Line @ {b, c, d, e}, Line @ {f, g, h, a},
		Line @ {c, i}, Line @ {d, j},
		Line @ {g, k}, Line @ {l, h}
};
	{
		Rotate[N[Pi]/2 {0, 2}, $o] @ figure,
		Rotate[N[Pi]/2 {1, 3}, $o] @ figure
	}
]

CrissCrossPolygons[m_, n_, x_] := Module[
	{y, a, b, c, d, e, f, g, h, i, j, k, l, color1, color2, figure},
	y = (.5 - x) / 2; 
	a = y $i / m; 
	b = (x+y) $i / m; 
	c = (x+y) $i / m + y $j / m;
	d = (x+y) $i / m + (x+y) $j / n; 
	e = (x+y) $i / m + .5 $j / n; 
	f = y $i / m + .5 $j / n;
	g = y $i / m + (x+y) $j / n;
	h = y $i / m + y $j / n;
	i = .5 $i / m + y $j / n; 
	j = .5 $i / m + (x+y) $j / n;
	k = (x+y) $j / n;
	l = y $j / n; 
	figure = { 
		{EdgeForm[], color1,
			 Polygon @ {a, b, c, d, e, f, g, h}},
		{EdgeForm[], color2, 
			Polygon @ {c, i, j, d}, Polygon @ {h, g, k, l}}	 
	};
	{
		Rotate[N[Pi]/2 {0, 2}, $o] @ figure /. 
			{color1 -> Red, color2 -> Blue},
		Rotate[N[Pi]/2 {1, 3}, $o] @ figure /. 
			{color1 -> Blue, color2 -> Red}
	}
]
