
Latitudes::usage = "Latitudes[{u0, u1, du}, {v0, v1, dv}] (in complex) gives 
a list of parts of the latitudes on the sphere between angles v0 and v1 with 
a spacing of dv. The parts are between great circles at the angles u0 and u1 
with a spacing of du.
Latitudes[f, m, n, c] (in surfaces) is the image of n horizontal lines of 
colour c with m points each under the mapping f: R ^ 2 -> R ^ 3."

Latitudes[f_, m_?NumberQ, n_?NumberQ, c_] := 
	Transformation[f] @ 
	Translate[Lattice[m, $i / m, n + 1, $j / n]] @ 
	{Thickness[.0035], c, Line @ {$o, $i / m}}

