
Rotate::usage = "2D: Rotate[a, p][g] is the rotation of the figure g about the 
point p through the angle a. 
3D: Rotate[a, l][g] is the rotation of the figure g through the angle a about 
the line l."

Rotate[a_?NumberQ, q_?PointQ] @ p_?PointQ := Module[
	{pp, qq},
	pp = Take[p, 2];
	qq = Take[q, 2];
	Append[
		PairProduct[pp - qq, {Cos[a], Sin[a]}] + qq,
	0.] ] 

Rotate[a_?NumberQ, q_?PointQ] @ g_ := 
	MapAt[Rotate[a, q], g, Position[g, _?PointQ]] 

Rotate[l_List, q_?PointQ] @ g_ := Rotate[#, q] @ g & /@ l 

Rotate[a_?NumberQ, Line @ {q_, r_}] @ p_?PointQ := Module[
	{
		s = Prepend[Sin[a / 2] Unit[r - q], Cos[a / 2]],
		t = Prepend[p - q, 0]
	}, 
	q + Chop @ Drop[QTimes[QTimes[QReciprocal[s], t], s], 1] ] 

Rotate[a_?NumberQ, l_Line] @ g_ := 
	MapAt[Rotate[a, l], g, Position[g, _?PointQ]] 

Rotate[a_?NumberQ, l_List] @ g_ := Rotate[a, #] @ g & /@ l

Rotate[a_, Plane @ {{0.,0.,0.,0.}, u_, v_}] @ q_ := (
u ~QTimes~ # ~QTimes~ QConjugate[u]
	 ~QTimes~ q ~QTimes~ QConjugate[#]&
	 [Cos[a/2] {1,0,0,0} + Sin[a/2] u ~QTimes~ v])

Rotate[a_List, l_] @ g_ := Rotate[#, l] @ g & /@ a

