
Wheel::usage = "Wheel[l, r, (n:$PointsOnCircle)] gives a Circle3D of radius r, 
centre at the midpoint of the line l, and plane normal to l. Wheel[l, r] gives 
a list of Circle3D's if l or r are lists."

( Wheel[Line @ {p_, q_}, r_?NumberQ, n_:$PointsOnCircle] := 
	Translate[(p + q) / 2] @ Circle3D[$o, r $i, r $j, n] 
	/; Cross[$k, q - p] == $o 
)

Wheel[Line @ {p_, q_}, r_?NumberQ, n_:$PointsOnCircle] := 
	Translate[(p + q) / 2] @ Rotate[
		Angle[$k, q - p], 
		Line @ {$o, Cross[$k, q - p]}
	] @ Circle3D[$o, r $i, r $j, n]

Wheel[l_List, r_?NumberQ, n_:$PointsOnCircle] := Wheel[#, r]& /@ l

Wheel[l_, r_List, n_:$PointsOnCircle] := Flatten[Wheel[l, #]& /@ r]

