
Dilate::usage = "Dilate[x, c][g] is the magnification of the figure g by 
the factor x with c as centre."

Dilate[x_?NumberQ, z_?PointQ] @ p_?PointQ := z + x (p - z) 

Dilate[x_?PointQ, z_?PointQ] @ Point[p_?PointQ] := Point[z + x (p - z)] 

Dilate[x_?NumberQ, z_?PointQ] @ Line @ g_ := 
	Line @ MapAt[z + x (# - z) &, g, Position[g, _?PointQ]] 

Dilate[x_?NumberQ, z_?PointQ] @ Polygon @ g_ := 
	Polygon @ MapAt[z + x (# - z) &, g, Position[g, _?PointQ]] 

Dilate[x_?NumberQ, z_?PointQ] @ Circle[c_, r_] := 
	Circumcircle @ Dilate[x, z] @ {c + r $i, c + r $j, c - r $i} 

Dilate[x_?NumberQ, z_?PointQ] @ Circle[c_, r_, n_] := 
	Append[Dilate[x, z] @ Circle[c, r], n] 

Dilate[x_?NumberQ, z_?PointQ] @ Circle3D[c_, d_, e_] := 
	Apply[Circle3D, Dilate[x, z] /@ {c, d, e}] 

Dilate[x_?NumberQ, z_?PointQ] @ Circle3D[c_, d_, e_, n_] := 
	Append[Dilate[x, z] @ Circle3D[c, d, e], n] 

Dilate[x_?NumberQ, z_?PointQ] @ u_Disk := 
	Disk @@ Dilate[x, z][Circle @@ u] 

Dilate[x_?NumberQ, z_?PointQ] @ Plane @ {p_, q_, r_} := 
	Plane @ Dilate[x, z] @ {p, q, r} 

Dilate[x_?NumberQ, z_?PointQ] @ Sphere[c_, r_] := Circumsphere @ 
	Dilate[x, z] @ {c + r $i, c + r $j, c + r $k, c - r $i} 

Dilate[x_?NumberQ, z_?PointQ] @ Text[t_, p_?PointQ, a___] := 
	Text[t, Dilate[x, z] @ p, a] 

Dilate[_?NumberQ, z_?PointQ] @ GrayLevel[i_] := GrayLevel[i] 

Dilate[_?NumberQ, z_?Point] @ RGBColor[r_, g_, b_] := RGBColor[r, g, b] 

Dilate[_?NumberQ, z_?PointQ] @ PointSize[s_] := PointSize[s] 

Dilate[_?NumberQ, z:_?PointQ] @ Thickness[t_] := Thickness[t] 

Dilate[_?NumberQ, z_?PointQ] @ Dashing[d_] := Dashing[d] 

Dilate[_?NumberQ, z_?PointQ] @ EdgeForm[] := EdgeForm[] 

Dilate[_?NumberQ, z_?PointQ] @ EdgeForm[e_] := EdgeForm[e] 

Dilate[x_?NumberQ, l_] @ g_List := Dilate[x, l] /@ g

Dilate[x_?NumberQ, l_List] @ g_ := Dilate[x, #] @ g & /@ l

Dilate[l_List, z_] @ g_ := Dilate[#, z] @ g & /@ l

