
TopBoundary::usage = "TopBoundary[f, m, n, c] is the image under the mapping 
f: R ^ 2 -> R ^ 3 of colour c of the line at the top of the unit square made 
up of m n small rectangles which touches the axes in the first quadrant."

BottomBoundary::usage = "BottomBoundary[f, m, n, c] is the image under the 
mapping f: R ^ 2 -> R ^ 3 of colour c of the line at the top of the unit 
square made up of m n small rectangles which touches the axes in the first 
quadrant."

LeftBoundary::usage = "LeftBoundary[f, m, n, c] is the image under the 
mapping f: R ^ 2 -> R ^ 3 of colour c of the line at the left side of the unit 
square made up of m n small rectangles which touches the axes in the first 
quadrant."

RightBoundary::usage = "RightBoundary[f, m, n, c] is the image under the 
mapping f: R ^ 2 -> R ^ 3 of colour c of the line at the right side of the 
unit square made up of m n small rectangles which touches the axes in the 
first quadrant."

TopBoundary[f_, m_?NumberQ, n_?NumberQ, c_] := Transformation[f] @  
	{
		Thickness[.0035], c, 
		Translate[$j] @ Line[Lattice[m + 1, $i / m]]
	} 

BottomBoundary[f_, m_?NumberQ, n_?NumberQ, c_] := Transformation[f] @
	{Thickness[.0035], c, Line[Lattice[m + 1, $i / m]]} 

LeftBoundary[f_, m_?NumberQ, n_?NumberQ, c_] := Transformation[f] @
	{Thickness[.0035], c, Line[Lattice[n + 1, $j / n]]} 

RightBoundary[f_, m_?NumberQ, n_?NumberQ, c_] := Transformation[f] @
	{
		Thickness[.0035], c, 
		Translate[$i] @ Line[Lattice[n + 1, $j / n]]
	} 

Boundary[f_, m_?NumberQ, n_?NumberQ, c_] := 
	{
		TopBoundary[f, m ,n ,c],
		BottomBoundary[f, m ,n ,c],
		LeftBoundary[f, m ,n ,c],
		RightBoundary[f, m ,n ,c]
	} 

