
ColouredTiles::usage = "ColouredTiles[f, m, n] is the image of m n coloured 
rectangles under the mapping f: R ^ 2 -> R ^ 3."

ColouredTiles[f_, m_?NumberQ, n_?NumberQ] := Module[
	{lattice, colours, figure},
	lattice = Lattice[m, $i / m, n, $j / n];
	colours = Map[RGBColor @@ N[Sqrt[#]] &, lattice]; 
	figure = Transformation[f] @ 
		Translate[lattice] @ 
		Dilate[.6, $o] @ 
		Polygon[{$o, 1 / m $i, 1 / m $i + 1 / n $j, 1 / n $j}]; 
	Thread @ {colours, figure}
] 
